diff --git a/pki/base/common/src/com/netscape/cms/servlet/admin/CAAdminServlet.java b/pki/base/common/src/com/netscape/cms/servlet/admin/CAAdminServlet.java
index fa3933ed6105b0c4368a7c3dfe2b620210cd0d91..2c6ba3dbcdb6b2081e3561eeacd7dfdd5df7a081 100644
--- a/pki/base/common/src/com/netscape/cms/servlet/admin/CAAdminServlet.java
+++ b/pki/base/common/src/com/netscape/cms/servlet/admin/CAAdminServlet.java
@@ -230,10 +230,11 @@ public class CAAdminServlet extends AdminServlet {
             IOException, EBaseException {
 
         NameValuePairs params = new NameValuePairs();
-        Enumeration e = req.getParameterNames();
+        @SuppressWarnings("unchecked")
+        Enumeration<String> e = req.getParameterNames();
 
         while (e.hasMoreElements()) {
-            String name = (String) e.nextElement();
+            String name = e.nextElement();
 
             if (name.equals(Constants.OP_TYPE))
                 continue;
@@ -290,10 +291,11 @@ public class CAAdminServlet extends AdminServlet {
 
         IConfigStore riq = nc.getSubStore(ICertificateAuthority.PROP_REQ_IN_Q_SUBSTORE);
 
-        Enumeration e = req.getParameterNames();
+        @SuppressWarnings("unchecked")
+        Enumeration<String> e = req.getParameterNames();
 
         while (e.hasMoreElements()) {
-            String name = (String) e.nextElement();
+            String name = e.nextElement();
 
             if (name.equals(Constants.OP_TYPE))
                 continue;
@@ -324,10 +326,11 @@ public class CAAdminServlet extends AdminServlet {
         IConfigStore riq = nc.getSubStore(ICertificateAuthority.PROP_REQ_IN_Q_SUBSTORE);
 
         //set rest of the parameters
-        Enumeration e = req.getParameterNames();
+        @SuppressWarnings("unchecked")
+        Enumeration<String> e = req.getParameterNames();
 
         while (e.hasMoreElements()) {
-            String name = (String) e.nextElement();
+            String name = e.nextElement();
 
             if (name.equals(Constants.OP_TYPE))
                 continue;
@@ -379,10 +382,11 @@ public class CAAdminServlet extends AdminServlet {
             IOException, EBaseException {
 
         //set rest of the parameters
-        Enumeration e = req.getParameterNames();
+        @SuppressWarnings("unchecked")
+        Enumeration<String> e = req.getParameterNames();
 
         while (e.hasMoreElements()) {
-            String name = (String) e.nextElement();
+            String name = e.nextElement();
 
             if (name.equals(Constants.OP_TYPE))
                 continue;
@@ -456,10 +460,10 @@ public class CAAdminServlet extends AdminServlet {
             throws ServletException, IOException, EBaseException {
         NameValuePairs params = new NameValuePairs();
 
-        Enumeration ips = mCA.getCRLIssuingPoints();
+        Enumeration<ICRLIssuingPoint> ips = mCA.getCRLIssuingPoints();
 
         while (ips.hasMoreElements()) {
-            ICRLIssuingPoint ip = (ICRLIssuingPoint) ips.nextElement();
+            ICRLIssuingPoint ip = ips.nextElement();
 
             if (ip != null) {
                 String ipId = ip.getId();
@@ -486,11 +490,12 @@ public class CAAdminServlet extends AdminServlet {
 
             if (ip != null) {
 
-                Enumeration e = req.getParameterNames();
+                @SuppressWarnings("unchecked")
+                Enumeration<String> e = req.getParameterNames();
                 String value = "";
 
                 while (e.hasMoreElements()) {
-                    String name = (String) e.nextElement();
+                    String name = e.nextElement();
 
                     if (name.equals(Constants.PR_ENABLED)) {
                         if (ip.isCRLIssuingPointEnabled()) {
@@ -586,10 +591,10 @@ public class CAAdminServlet extends AdminServlet {
 
             IConfigStore crlSubStore =
                     mCA.getConfigStore().getSubStore(ICertificateAuthority.PROP_CRL_SUBSTORE);
-            Enumeration crlNames = crlSubStore.getSubStoreNames();
+            Enumeration<String> crlNames = crlSubStore.getSubStoreNames();
 
             while (crlNames.hasMoreElements()) {
-                String name = (String) crlNames.nextElement();
+                String name = crlNames.nextElement();
 
                 if (ipId.equals(name)) {
                     // store a message in the signed audit log file
@@ -743,10 +748,10 @@ public class CAAdminServlet extends AdminServlet {
             IConfigStore crlSubStore =
                     mCA.getConfigStore().getSubStore(ICertificateAuthority.PROP_CRL_SUBSTORE);
             boolean done = false;
-            Enumeration crlNames = crlSubStore.getSubStoreNames();
+            Enumeration<String> crlNames = crlSubStore.getSubStoreNames();
 
             while (crlNames.hasMoreElements()) {
-                String name = (String) crlNames.nextElement();
+                String name = crlNames.nextElement();
 
                 if (ipId.equals(name)) {
                     ICRLIssuingPoint ip = mCA.getCRLIssuingPoint(ipId);
@@ -862,10 +867,10 @@ public class CAAdminServlet extends AdminServlet {
                 IConfigStore crlSubStore =
                         mCA.getConfigStore().getSubStore(ICertificateAuthority.PROP_CRL_SUBSTORE);
                 boolean done = false;
-                Enumeration crlNames = crlSubStore.getSubStoreNames();
+                Enumeration<String> crlNames = crlSubStore.getSubStoreNames();
 
                 while (crlNames.hasMoreElements()) {
-                    String name = (String) crlNames.nextElement();
+                    String name = crlNames.nextElement();
 
                     if (id.equals(name)) {
                         mCA.deleteCRLIssuingPoint(crlSubStore, id);
@@ -944,10 +949,11 @@ public class CAAdminServlet extends AdminServlet {
         NameValuePairs params = new NameValuePairs();
 
         String ipId = null;
-        Enumeration e = req.getParameterNames();
+        @SuppressWarnings("unchecked")
+        Enumeration<String> e = req.getParameterNames();
 
         while (e.hasMoreElements()) {
-            String name = (String) e.nextElement();
+            String name = e.nextElement();
 
             if (name.equals(Constants.OP_TYPE))
                 continue;
@@ -1019,10 +1025,11 @@ public class CAAdminServlet extends AdminServlet {
             if (id != null) {
                 IConfigStore crlExtSubStore = crlExtsSubStore.getSubStore(id);
 
-                Enumeration e = req.getParameterNames();
+                @SuppressWarnings("unchecked")
+                Enumeration<String> e = req.getParameterNames();
 
                 while (e.hasMoreElements()) {
-                    String name = (String) e.nextElement();
+                    String name = e.nextElement();
 
                     if (name.equals(Constants.OP_TYPE))
                         continue;
@@ -1110,16 +1117,16 @@ public class CAAdminServlet extends AdminServlet {
         IConfigStore crlExtsSubStore = crlSubStore.getSubStore(ICertificateAuthority.PROP_CRLEXT_SUBSTORE);
 
         if (crlExtsSubStore != null) {
-            Enumeration enumExts = crlExtsSubStore.getSubStoreNames();
+            Enumeration<String> enumExts = crlExtsSubStore.getSubStoreNames();
 
             while (enumExts.hasMoreElements()) {
-                String extName = (String) enumExts.nextElement();
+                String extName = enumExts.nextElement();
                 boolean crlExtEnabled = false;
                 IConfigStore crlExtSubStore = crlExtsSubStore.getSubStore(extName);
-                Enumeration properties = crlExtSubStore.getPropertyNames();
+                Enumeration<String> properties = crlExtSubStore.getPropertyNames();
 
                 while (properties.hasMoreElements()) {
-                    String name = (String) properties.nextElement();
+                    String name = properties.nextElement();
 
                     if (name.equals(Constants.PR_ENABLE)) {
                         crlExtEnabled = crlExtSubStore.getBoolean(name, false);
@@ -1158,9 +1165,9 @@ public class CAAdminServlet extends AdminServlet {
         String ipId = null;
         String name = null;
 
-        Enumeration ips = mCA.getCRLIssuingPoints();
+        Enumeration<ICRLIssuingPoint> ips = mCA.getCRLIssuingPoints();
         if (ips.hasMoreElements()) {
-            ICRLIssuingPoint ip = (ICRLIssuingPoint) ips.nextElement();
+            ICRLIssuingPoint ip = ips.nextElement();
             if (ip != null) {
                 ipId = ip.getId();
             }
@@ -1229,10 +1236,11 @@ public class CAAdminServlet extends AdminServlet {
             IConfigStore crlSubStore = crlsSubStore.getSubStore(id);
 
             //set reset of the parameters
-            Enumeration e = req.getParameterNames();
+            @SuppressWarnings("unchecked")
+            Enumeration<String> e = req.getParameterNames();
 
             while (e.hasMoreElements()) {
-                String name = (String) e.nextElement();
+                String name = e.nextElement();
 
                 if (name.equals(Constants.OP_TYPE))
                     continue;
@@ -1319,10 +1327,11 @@ public class CAAdminServlet extends AdminServlet {
                 mCA.getConfigStore().getSubStore(ICertificateAuthority.PROP_CRL_SUBSTORE);
         IConfigStore crlSubStore = crlsSubStore.getSubStore(id);
 
-        Enumeration e = req.getParameterNames();
+        @SuppressWarnings("unchecked")
+        Enumeration<String> e = req.getParameterNames();
 
         while (e.hasMoreElements()) {
-            String name = (String) e.nextElement();
+            String name = e.nextElement();
 
             if (name.equals(Constants.OP_TYPE))
                 continue;
@@ -1352,12 +1361,13 @@ public class CAAdminServlet extends AdminServlet {
             caConnectorConfig = connectorConfig.getSubStore("CLA");
         }
 
-        Enumeration enum1 = req.getParameterNames();
+        @SuppressWarnings("unchecked")
+        Enumeration<String> enum1 = req.getParameterNames();
         NameValuePairs params = new NameValuePairs();
 
         if (caConnectorConfig != null) {
             while (enum1.hasMoreElements()) {
-                String name = (String) enum1.nextElement();
+                String name = enum1.nextElement();
 
                 if (name.equals(Constants.RS_ID))
                     continue;
@@ -1388,11 +1398,12 @@ public class CAAdminServlet extends AdminServlet {
             caConnectorConfig = connectorConfig.getSubStore("CLA");
         }
 
-        Enumeration enum1 = req.getParameterNames();
+        @SuppressWarnings("unchecked")
+        Enumeration<String> enum1 = req.getParameterNames();
 
         if (caConnectorConfig != null) {
             while (enum1.hasMoreElements()) {
-                String name = (String) enum1.nextElement();
+                String name = enum1.nextElement();
 
                 if (name.equals(Constants.OP_TYPE))
                     continue;
@@ -1423,10 +1434,11 @@ public class CAAdminServlet extends AdminServlet {
     }
 
     private boolean isKRAConnector(HttpServletRequest req) {
-        Enumeration enum1 = req.getParameterNames();
+        @SuppressWarnings("unchecked")
+        Enumeration<String> enum1 = req.getParameterNames();
 
         while (enum1.hasMoreElements()) {
-            String key = (String) enum1.nextElement();
+            String key = enum1.nextElement();
 
             if (key.equals("RS_ID")) {
                 String val = req.getParameter(key);
@@ -1441,10 +1453,11 @@ public class CAAdminServlet extends AdminServlet {
     }
 
     private boolean isCLAConnector(HttpServletRequest req) {
-        Enumeration enum1 = req.getParameterNames();
+        @SuppressWarnings("unchecked")
+        Enumeration<String> enum1 = req.getParameterNames();
 
         while (enum1.hasMoreElements()) {
-            String key = (String) enum1.nextElement();
+            String key = enum1.nextElement();
 
             if (key.equals("RS_ID")) {
                 String val = req.getParameter(key);
@@ -1532,12 +1545,12 @@ public class CAAdminServlet extends AdminServlet {
 
         IConfigStore caConfig = mCA.getConfigStore();
 
-        Enumeration enum1 = req.getParameterNames();
+        Enumeration<String> enum1 = req.getParameterNames();
         boolean restart = false;
 
         //mCA.setMaxSerial("");
         while (enum1.hasMoreElements()) {
-            String key = (String) enum1.nextElement();
+            String key = enum1.nextElement();
             String value = req.getParameter(key);
 
             if (key.equals(Constants.PR_EE_ENABLED)) {
diff --git a/pki/base/common/src/com/netscape/cms/servlet/admin/JobsAdminServlet.java b/pki/base/common/src/com/netscape/cms/servlet/admin/JobsAdminServlet.java
index 7ebb64af1c17acaa5ca1a379112c03ce0513d323..b93e6eb0b6e5786fe638728534cf1103ca562562 100644
--- a/pki/base/common/src/com/netscape/cms/servlet/admin/JobsAdminServlet.java
+++ b/pki/base/common/src/com/netscape/cms/servlet/admin/JobsAdminServlet.java
@@ -520,12 +520,11 @@ public class JobsAdminServlet extends AdminServlet {
             IOException, EBaseException {
 
         NameValuePairs params = new NameValuePairs();
-        Enumeration e = mJobsSched.getPlugins().keys();
+        Enumeration<String> e = mJobsSched.getPlugins().keys();
 
         while (e.hasMoreElements()) {
-            String name = (String) e.nextElement();
-            JobPlugin value = (JobPlugin)
-                    mJobsSched.getPlugins().get(name);
+            String name = e.nextElement();
+            JobPlugin value = mJobsSched.getPlugins().get(name);
 
             params.add(name, value.getClassPath());
             //				params.add(name, value.getClassPath()+EDIT);
@@ -540,10 +539,9 @@ public class JobsAdminServlet extends AdminServlet {
 
         NameValuePairs params = new NameValuePairs();
 
-        for (Enumeration e = mJobsSched.getInstances().keys(); e.hasMoreElements();) {
-            String name = (String) e.nextElement();
-            IJob value = (IJob)
-                    mJobsSched.getInstances().get((Object) name);
+        for (Enumeration<String> e = mJobsSched.getInstances().keys(); e.hasMoreElements();) {
+            String name = e.nextElement();
+            IJob value = mJobsSched.getInstances().get((Object) name);
 
             //				params.add(name, value.getImplName());
             params.add(name, value.getImplName() + VISIBLE +
@@ -581,8 +579,8 @@ public class JobsAdminServlet extends AdminServlet {
 
         // first check if any instances from this job plugin
         // DON'T remove job plugin if any instance
-        for (Enumeration e = mJobsSched.getInstances().elements(); e.hasMoreElements();) {
-            IJob jobs = (IJob) e.nextElement();
+        for (Enumeration<IJob> e = mJobsSched.getInstances().elements(); e.hasMoreElements();) {
+            IJob jobs = e.nextElement();
 
             if ((jobs.getImplName()).equals(id)) {
                 sendResponse(ERROR,
@@ -1001,10 +999,10 @@ public class JobsAdminServlet extends AdminServlet {
         store.removeSubStore(id);
         IConfigStore rstore = store.makeSubStore(id);
 
-        Enumeration keys = saveParams.getNames();
+        Enumeration<String> keys = saveParams.getNames();
 
         while (keys.hasMoreElements()) {
-            String key = (String) keys.nextElement();
+            String key = keys.nextElement();
             String value = saveParams.getValue(key);
 
             if (!value.equals(""))
diff --git a/pki/base/common/src/com/netscape/cms/servlet/admin/KRAAdminServlet.java b/pki/base/common/src/com/netscape/cms/servlet/admin/KRAAdminServlet.java
index 1dd346667a58c0b57e8f99ead07830b8a454d5b9..0d3648c98103c0952085f18e4a9461e65b0cc376 100644
--- a/pki/base/common/src/com/netscape/cms/servlet/admin/KRAAdminServlet.java
+++ b/pki/base/common/src/com/netscape/cms/servlet/admin/KRAAdminServlet.java
@@ -188,14 +188,15 @@ public class KRAAdminServlet extends AdminServlet {
     private void setGeneralConfig(HttpServletRequest req,
             HttpServletResponse resp) throws ServletException,
             IOException, EBaseException {
-        Enumeration enum1 = req.getParameterNames();
+        @SuppressWarnings("unchecked")
+        Enumeration<String> enum1 = req.getParameterNames();
         boolean restart = false;
 
         String auditMessage = null;
         String auditSubjectID = auditSubjectID();
 
         while (enum1.hasMoreElements()) {
-            String key = (String) enum1.nextElement();
+            String key = enum1.nextElement();
             String value = req.getParameter(key);
 
             if (key.equals(Constants.PR_NO_OF_REQUIRED_RECOVERY_AGENTS)) {
diff --git a/pki/base/common/src/com/netscape/cms/servlet/admin/OCSPAdminServlet.java b/pki/base/common/src/com/netscape/cms/servlet/admin/OCSPAdminServlet.java
index 338a5823973171b227677306212922d0def5f5a7..317a50d683099404f679aa53708fe7567f80cc9f 100644
--- a/pki/base/common/src/com/netscape/cms/servlet/admin/OCSPAdminServlet.java
+++ b/pki/base/common/src/com/netscape/cms/servlet/admin/OCSPAdminServlet.java
@@ -344,10 +344,11 @@ public class OCSPAdminServlet extends AdminServlet {
 
             IOCSPStore store = mOCSP.getOCSPStore(id);
 
-            Enumeration e = req.getParameterNames();
+            @SuppressWarnings("unchecked")
+            Enumeration<String> e = req.getParameterNames();
 
             while (e.hasMoreElements()) {
-                String name = (String) e.nextElement();
+                String name = e.nextElement();
 
                 if (name.equals(Constants.OP_TYPE))
                     continue;
@@ -422,10 +423,10 @@ public class OCSPAdminServlet extends AdminServlet {
         IConfigStore config = mOCSP.getConfigStore();
         String defStore = config.getString(IOCSPAuthority.PROP_DEF_STORE_ID);
         IConfigStore SubStore = config.getSubStore(IOCSPAuthority.PROP_STORE);
-        Enumeration enumStores = SubStore.getSubStoreNames();
+        Enumeration<String> enumStores = SubStore.getSubStoreNames();
 
         while (enumStores.hasMoreElements()) {
-            String storeName = (String) enumStores.nextElement();
+            String storeName = enumStores.nextElement();
             boolean storeEnabled = false;
 
             if (storeName.equals(defStore)) {
@@ -488,7 +489,8 @@ public class OCSPAdminServlet extends AdminServlet {
         // ensure that any low-level exceptions are reported
         // to the signed audit log and stored as failures
         try {
-            Enumeration enum1 = req.getParameterNames();
+            @SuppressWarnings("unchecked")
+            Enumeration<String> enum1 = req.getParameterNames();
             boolean restart = false;
 
             while (enum1.hasMoreElements()) {
diff --git a/pki/base/common/src/com/netscape/cms/servlet/admin/PolicyAdminServlet.java b/pki/base/common/src/com/netscape/cms/servlet/admin/PolicyAdminServlet.java
index f34a827706d1aecba1c15eaaeb850ab5536efea6..4dbde7e062158037b064a8ab93f65f2b06cd44c9 100644
--- a/pki/base/common/src/com/netscape/cms/servlet/admin/PolicyAdminServlet.java
+++ b/pki/base/common/src/com/netscape/cms/servlet/admin/PolicyAdminServlet.java
@@ -428,8 +428,8 @@ public class PolicyAdminServlet extends AdminServlet {
     public void listPolicyImpls(HttpServletRequest req,
             HttpServletResponse resp)
             throws ServletException, IOException {
-        Enumeration policyImplNames = mProcessor.getPolicyImplsInfo();
-        Enumeration policyImpls = mProcessor.getPolicyImpls();
+        Enumeration<String> policyImplNames = mProcessor.getPolicyImplsInfo();
+        Enumeration<IPolicyRule> policyImpls = mProcessor.getPolicyImpls();
 
         if (policyImplNames == null ||
                 policyImpls == null) {
@@ -442,9 +442,8 @@ public class PolicyAdminServlet extends AdminServlet {
 
         while (policyImplNames.hasMoreElements() &&
                 policyImpls.hasMoreElements()) {
-            String id = (String) policyImplNames.nextElement();
-            IPolicyRule impl = (IPolicyRule)
-                    policyImpls.nextElement();
+            String id = policyImplNames.nextElement();
+            IPolicyRule impl = policyImpls.nextElement();
             String className =
                     impl.getClass().getName();
             String desc = impl.getDescription();
@@ -457,7 +456,7 @@ public class PolicyAdminServlet extends AdminServlet {
     public void listPolicyInstances(HttpServletRequest req,
             HttpServletResponse resp)
             throws ServletException, IOException {
-        Enumeration instancesInfo = mProcessor.getPolicyInstancesInfo();
+        Enumeration<String> instancesInfo = mProcessor.getPolicyInstancesInfo();
 
         if (instancesInfo == null) {
             sendResponse(ERROR, INVALID_POLICY_INSTANCE_CONFIG, null, resp);
@@ -469,7 +468,7 @@ public class PolicyAdminServlet extends AdminServlet {
         String instName, rest;
 
         while (instancesInfo.hasMoreElements()) {
-            String info = (String) instancesInfo.nextElement();
+            String info = instancesInfo.nextElement();
             int i = info.indexOf(";");
 
             nvp.add(info.substring(0, i), info.substring(i + 1));
@@ -583,7 +582,7 @@ public class PolicyAdminServlet extends AdminServlet {
             return;
         }
 
-        Vector v = mProcessor.getPolicyImplConfig(id);
+        Vector<String> v = mProcessor.getPolicyImplConfig(id);
 
         if (v == null) {
             sendResponse(ERROR, INVALID_POLICY_IMPL_ID, null, resp);
@@ -591,8 +590,8 @@ public class PolicyAdminServlet extends AdminServlet {
         }
         NameValuePairs nvp = new NameValuePairs();
 
-        for (Enumeration e = v.elements(); e.hasMoreElements();) {
-            String nv = (String) e.nextElement();
+        for (Enumeration<String> e = v.elements(); e.hasMoreElements();) {
+            String nv = e.nextElement();
             int index = nv.indexOf("=");
 
             nvp.add(nv.substring(0, index), nv.substring(index + 1));
@@ -812,7 +811,7 @@ public class PolicyAdminServlet extends AdminServlet {
             return;
         }
 
-        Vector v = mProcessor.getPolicyInstanceConfig(id);
+        Vector<String> v = mProcessor.getPolicyInstanceConfig(id);
 
         if (v == null) {
             sendResponse(ERROR, INVALID_POLICY_INST_ID, null, resp);
@@ -820,8 +819,8 @@ public class PolicyAdminServlet extends AdminServlet {
         }
         NameValuePairs nvp = new NameValuePairs();
 
-        for (Enumeration e = v.elements(); e.hasMoreElements();) {
-            String nv = (String) e.nextElement();
+        for (Enumeration<String> e = v.elements(); e.hasMoreElements();) {
+            String nv = e.nextElement();
             int index = nv.indexOf("=");
             String name = nv.substring(0, index);
             String value = nv.substring(index + 1);
@@ -907,7 +906,7 @@ public class PolicyAdminServlet extends AdminServlet {
             // We need to fetch parameters: enable, predicate and implname
             // always, and any additional parameters as required by the
             // implementation.
-            Hashtable ht = new Hashtable();
+            Hashtable<String, String> ht = new Hashtable<String, String>();
             String val = req.getParameter(IPolicyRule.PROP_ENABLE).trim();
 
             if (val == null)
@@ -919,7 +918,7 @@ public class PolicyAdminServlet extends AdminServlet {
                 ht.put(IPolicyRule.PROP_PREDICATE, val);
             ht.put(IPolicyRule.PROP_IMPLNAME, implName);
 
-            Vector v = mProcessor.getPolicyImplConfig(implName);
+            Vector<String> v = mProcessor.getPolicyImplConfig(implName);
 
             if (v == null) {
                 // Invalid impl id
@@ -936,8 +935,8 @@ public class PolicyAdminServlet extends AdminServlet {
                 sendResponse(ERROR, INVALID_POLICY_IMPL_ID, null, resp);
                 return;
             }
-            for (Enumeration e = v.elements(); e.hasMoreElements();) {
-                String nv = (String) e.nextElement();
+            for (Enumeration<String> e = v.elements(); e.hasMoreElements();) {
+                String nv = e.nextElement();
                 int index = nv.indexOf("=");
                 String key = nv.substring(0, index);
 
@@ -1155,7 +1154,7 @@ public class PolicyAdminServlet extends AdminServlet {
             // We need to fetch parameters: enable, predicate and implname
             // always, and any additional parameters as required by the
             // implementation.
-            Hashtable ht = new Hashtable();
+            Hashtable<String, String> ht = new Hashtable<String, String>();
             String val = req.getParameter(IPolicyRule.PROP_ENABLE).trim();
 
             if (val == null)
@@ -1166,7 +1165,7 @@ public class PolicyAdminServlet extends AdminServlet {
             if (val != null)
                 ht.put(IPolicyRule.PROP_PREDICATE, val);
             ht.put(IPolicyRule.PROP_IMPLNAME, implName);
-            Vector v = mProcessor.getPolicyImplConfig(implName);
+            Vector<String> v = mProcessor.getPolicyImplConfig(implName);
 
             if (v == null) {
                 // Invalid impl id
@@ -1184,9 +1183,10 @@ public class PolicyAdminServlet extends AdminServlet {
                 return;
             }
             // XXX 
-            for (Enumeration n = req.getParameterNames(); n.hasMoreElements();) {
-                String p = (String) n.nextElement();
-                String l = (String) req.getParameter(p);
+            for (@SuppressWarnings("unchecked")
+            Enumeration<String> n = req.getParameterNames(); n.hasMoreElements();) {
+                String p = n.nextElement();
+                String l = req.getParameter(p);
 
                 if (l != null)
                     ht.put(p, l);
diff --git a/pki/base/common/src/com/netscape/cms/servlet/base/DynamicVariablesServlet.java b/pki/base/common/src/com/netscape/cms/servlet/base/DynamicVariablesServlet.java
index 2308318eea859f48c0f404c439491e128191ef66..b0a97e9b51ccd7355b1b9770231df7d9eff6ce46 100644
--- a/pki/base/common/src/com/netscape/cms/servlet/base/DynamicVariablesServlet.java
+++ b/pki/base/common/src/com/netscape/cms/servlet/base/DynamicVariablesServlet.java
@@ -86,7 +86,7 @@ public class DynamicVariablesServlet extends CMSServlet {
     private long mAuthMgrCacheTime = 0;
     private final int AUTHMGRCACHE = 10; //number of seconds to cache list of
     // authmanagers for
-    private Hashtable dynvars = null;
+    private Hashtable<Integer, String> dynvars = null;
     private String mGetClientCert = "false";
     private String mAuthMgr = null;
 
@@ -156,7 +156,7 @@ public class DynamicVariablesServlet extends CMSServlet {
             String dynvarconfig = sc.getInitParameter(PROP_DYNVAR);
             StringTokenizer s = new StringTokenizer(dynvarconfig, ",");
 
-            dynvars = new Hashtable();
+            dynvars = new Hashtable<Integer, String>();
 
             while (s.hasMoreTokens()) {
                 String token = s.nextToken();
@@ -181,7 +181,7 @@ public class DynamicVariablesServlet extends CMSServlet {
                     throw new ServletException("bad configuration parameter in " + PROP_DYNVAR);
                 }
                 if (varcode != null) {
-                    dynvars.put(varcode, (Object) varname);
+                    dynvars.put(varcode, varname);
                 }
             }
         } catch (Exception e) {
@@ -216,11 +216,11 @@ public class DynamicVariablesServlet extends CMSServlet {
 
             if (os != null) {
                 if (dynvars != null) {
-                    Enumeration k = dynvars.keys();
+                    Enumeration<Integer> k = dynvars.keys();
 
                     while (k.hasMoreElements()) {
                         String toBeWritten;
-                        Integer varcode = (Integer) k.nextElement();
+                        Integer varcode = k.nextElement();
 
                         if (varcode.equals(VAR_SERVERDATE)) {
                             toBeWritten = dynvars.get(varcode) +
@@ -264,7 +264,7 @@ public class DynamicVariablesServlet extends CMSServlet {
                         if (varcode.equals(VAR_AUTHMGRS)) {
                             toBeWritten = "";
                             IAuthSubsystem as = (IAuthSubsystem) CMS.getSubsystem(CMS.SUBSYSTEM_AUTH);
-                            Enumeration ame = as.getAuthManagers();
+                            Enumeration<IAuthManager> ame = as.getAuthManagers();
 
                             Date d = CMS.getCurrentDate();
                             long now = d.getTime();
@@ -274,7 +274,7 @@ public class DynamicVariablesServlet extends CMSServlet {
 
                                 StringBuffer sb = new StringBuffer();
                                 while (ame.hasMoreElements()) {
-                                    IAuthManager am = (IAuthManager) ame.nextElement();
+                                    IAuthManager am = ame.nextElement();
                                     String amName = am.getImplName();
 
                                     AuthMgrPlugin ap = as.getAuthManagerPluginImpl(amName);
diff --git a/pki/base/common/src/com/netscape/cms/servlet/base/GetStats.java b/pki/base/common/src/com/netscape/cms/servlet/base/GetStats.java
index f96cb0e1f3e792fcc8b356fc02978d76c6896b12..e145ee4db54ad7f911862ddac84bc4907b1806f6 100644
--- a/pki/base/common/src/com/netscape/cms/servlet/base/GetStats.java
+++ b/pki/base/common/src/com/netscape/cms/servlet/base/GetStats.java
@@ -165,9 +165,9 @@ public class GetStats extends CMSServlet {
     }
 
     public void parse(CMSTemplateParams argSet, StatsEvent st, int level) {
-        Enumeration names = st.getSubEventNames();
+        Enumeration<String> names = st.getSubEventNames();
         while (names.hasMoreElements()) {
-            String name = (String) names.nextElement();
+            String name = names.nextElement();
             StatsEvent subSt = st.getSubEvent(name);
 
             IArgBlock rarg = CMS.createArgBlock();
diff --git a/pki/base/common/src/com/netscape/cms/servlet/cert/CMCRevReqServlet.java b/pki/base/common/src/com/netscape/cms/servlet/cert/CMCRevReqServlet.java
index 461fa0b945cf0a0c8124fcb4a48ff19ba495d915..5fd3cd90292435e419f7e95ac4dbf01cc45d29b1 100644
--- a/pki/base/common/src/com/netscape/cms/servlet/cert/CMCRevReqServlet.java
+++ b/pki/base/common/src/com/netscape/cms/servlet/cert/CMCRevReqServlet.java
@@ -410,7 +410,7 @@ public class CMCRevReqServlet extends CMSServlet {
                 Enumeration<ICertRecord> e = list.getCertRecords(0, totalRecordCount - 1);
 
                 while (e != null && e.hasMoreElements()) {
-                    ICertRecord rec = (ICertRecord) e.nextElement();
+                    ICertRecord rec = e.nextElement();
                     X509CertImpl cert = rec.getCertificate();
                     IArgBlock rarg = CMS.createArgBlock();
 
